#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pii pair<int,int>
#define all(x) x.begin(), x.end()

const int max_n = 1e7 + 2;
const int inf = 1e9 + 7;

int right1[max_n];
int left1[max_n];
int ans[max_n];

signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#ifdef EDILYA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    int f;
    cin >> f;
    vector<int> a(n);
    if (f == 1) {
        for (int i = 0; i < n; i++)
            cin >> a[i];
    } else {
        int m, x, y, z;
        cin >> m >> x >> y >> z;
        for (int i = 0; i < m; i++)
            cin >> a[i];
        for (int i = m; i < n; i++)
            a[i] = ((1LL * x * a[i - 2] + y * a[i - 1] + z) % inf) + 1;
    }
    vector<pii> b(n);
    for (int i = 0; i < n; i++)
        b[i] = {a[i], i};
    //sort(all(b));
    stack<int> st;
    for (int i = 0; i < n; i++) {
        while (!st.empty() && a[st.top()] < a[i])
            st.pop();
        if (st.empty())
            left1[i] = -1;
        else
            left1[i] = st.top();
        st.emplace(i);
    }
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && a[st.top()] < a[i])
            st.pop();
        st.emplace(i);
    }
    sort(all(b));
    for (int i = 0; i < n; i++) {
        int ind = b[i].second;
        while (!st.empty() && a[st.top()] <= a[ind])
            st.pop();
        if (st.empty()) {
            right1[ind] = -1;
        } else {
            right1[ind] = st.top();
        }
    }

    ans[b[n - 1].second] = b[n - 1].first;
    pii glans = {inf, -1};
    for (int i = 1; i < n; i++) {
        int ind = b[n - i - 1].second;
        //cout << ind << '\n';
        if (right1[ind] != -1) {
            int dist = right1[ind] - ind;
            ans[ind] = max(b[ind].first, ans[right1[ind]] - dist);
        } else {
            int dist = n - (ind - left1[ind]);
            ans[ind] = max(b[ind].first, ans[left1[ind]] - dist);
        }
        if (ans[ind] < glans.first)
            glans = {ans[ind], ind + 1};
    }
    cout << glans.first << " " << glans.second << '\n';
}