#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pii pair<int,int>

const int max_n = 2e5 + 100;
const int inf = 1e9 + 7;

signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#ifdef EDILYA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < m; i++)
        cin >> b[i];
    int l = 0;
    int r = min(m, n);
    while (l + 1 < r) {
        int mid = (l + r) >> 1;
        bool ans = false;
        for (int i = 0; i + mid < n; i++) {
            for (int j = 0; j + mid < m; j++) {
                bool loc = true;
                for (int k = 0; k < mid; k++)
                    loc &= (a[i + k] + b[j + k]) == (a[i + mid - k] + b[j + mid - k]);
                ans |= loc;
            }
        }
        if (ans) l = mid;
        else r = mid;
    }
    cout << l + 1 << "\n";
}
