#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define pii pair<int,int>
#define all(x) x.begin(),x.end()

const int max_n = 1000;
const int inf = 1e9 + 7;


ll dp[max_n][max_n];
multiset<int> st[max_n][max_n];
ll sum[max_n][max_n];

signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#ifdef EDILYA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, k;
    cin >> n >> k;
    ll ans = 0;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    if (k == 0) {
        vector<ll> mem(n);
        mem[0] = a[0];
        for (int i = 1; i < n; i++) {
            mem[i] = max(mem[i - 1], 0LL) + a[i];
            ans = max(ans, mem[i]);
        }
        cout << ans << '\n';
        return 0;
    }
    vector<int> pref(n);
    for (int i = 0; i < n; i++)
        pref[i] = (i ? pref[i - 1] : 0) + a[i];
    for (int i = 0; i + k - 1 < n; i++) {
        for (int j = 0; j < k; j++) {
            st[i][i + k - 1].insert(a[i + j]);
            sum[i][i + k - 1] += a[i + j];
        }
    }
    for (int len = k + 1; len <= n; len++) {
        for (int l = 0, r = len - 1; r < n; l++, r++) {
            st[l][r] = st[l][r - 1];
            st[l][r].insert(a[r]);
            sum[l][r] = sum[l][r - 1] + a[r] - *st[l][r].begin();
            st[l][r].erase(st[l][r].begin());
            ll loc = pref[r] - (l ? pref[l - 1] : 0) - sum[l][r];
            //cout << l << " " << r << " " << loc << '\n';
            ans = max(ans, loc);
        }
    }
    cout << ans;
}