#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pii pair<int,int>
#define all(x) x.begin(), x.end()
#define ld long double
#define pld pair<ld,ld>
const int max_n = 2e5 + 2;
const int inf = 1e9 + 7;

struct prek {
    ld x[6];

    prek() {};
};

struct pt {
    ld x, y;

    pt() {}

    pt(ld x, ld y) : x(x), y(y) {}
};


ld dist(pt pt1, pt pt2) {
    ld x = pt1.x - pt2.x;
    ld y = pt1.y - pt2.y;
    return x * x + y * y;
}

pair<ld, ld> get(prek A) {
    pt pt1 = pt(A.x[0], A.x[1]);
    pt pt2 = pt(A.x[2], A.x[3]);
    pt pt3 = pt(A.x[4], A.x[5]);
    ld o1 = dist(pt1, pt2);
    ld o2 = dist(pt2, pt3);
    ld o3 = dist(pt3, pt1);
    ld cnt[3]{o1, o2, o3};
    sort(cnt, cnt + 3);
    return {cnt[0], cnt[1]};
}

bool eq(pld o1, pld o2) {
    return (o1.first == o2.first || o1.first == o2.second || o1.second == o2.first || o1.second == o2.second);
}

signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#ifdef EDILYA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;


    struct T {
        int a, b, c, d;

        T() {};

        T(int a, int b, int c, int d) : a(a), b(b), c(c), d(d) {}
    };
    ll n;
    cin >> n;
    vector<prek> a(n);
    for (int i = 0; i < n; i++) {
        for (auto &k: a[i].x) {
            cin >> k;
        }
    }
    //for (int i = 0; i < n; i++)
    //    cout << get(a[i]).first << " " << get(a[i]).second << '\n';
    vector<T> anss;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            for (int k = 0; k < n; k++) {
                if (i == k || j == k) continue;
                for (int c = 0; c < n; c++) {
                    if (c == i || c == j || c == k) continue;
                    pld o1 = get(a[i]);
                    pld o2 = get(a[j]);
                    pld o3 = get(a[k]);
                    pld o4 = get(a[c]);
                    bool ans = true;
                    if (o1 != o2) continue;
                    ans &= eq(o1, o3);
                    ans &= eq(o1, o4);
                    ans &= (o3.second / o3.first) == (o4.second / o4.first);
                    if (o3.first == o1.first) {
                        ans &= (o4.first == o1.second);
                    } else if (o3.first == o1.second) {
                        ans &= o1.first == o4.first;
                    } else if (o3.second == o1.first) {
                        ans &= o1.second == o3.first;
                    } else if (o3.second == o1.first) {
                        ans &= o1.second == o3.second;
                    } else {
                        ans = false;
                    }
                    if (ans)
                        anss.emplace_back(i, j, k, c);
                }
            }
        }
    }
    set<vector<int>> st;
    vector<T> ans2;
    for (auto o: anss) {
        vector<int> b{o.a, o.b, o.c, o.d};
        sort(all(b));
        if (st.count(b) == 0) {
            st.insert(b);
            ans2.emplace_back(o);
        }
    }
    cout << ans2.size() << '\n';
    for (auto o: ans2) {
        cout << o.a + 1 << " " << o.b + 1 << " " << o.c + 1 << " " << o.d + 1 << '\n';
    }
}
