#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pii pair<int,int>
#define all(x) x.begin(), x.end()

const int max_n = 2e5 + 2;
const int inf = 1e9 + 7;
#define double ll

struct prek {
    int x[6];

    prek() {};
};

struct pt {
    double x, y;
    pt(){}
    pt(double x, double y) : x(x), y(y){}
};


double dist(pt pt1, pt pt2) {
    double x = pt1.x - pt2.x;
    double y = pt1.y - pt2.y;
    return x * x + y * y;
}

ll get(prek A){
    pt pt1 = pt(A.x[0], A.x[1]);
    pt pt2 = pt(A.x[2], A.x[3]);
    pt pt3 = pt(A.x[4], A.x[5]);
    ll o1 = dist(pt1, pt2);
    ll o2 = dist(pt2, pt3);
    if ((ll)sqrt(o1) * (ll)sqrt(o1) != o1)
        return sqrt(o2);
    else return sqrt(o1);
}

signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#ifdef EDILYA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;


    struct T {
        int a, b, c, d;
        T(){};
        T(int a, int b, int c, int d) : a(a), b(b), c(c), d(d){}
    };
    if (t == 3) {
        ll n;
        cin >> n;
        for (int i = 0; i < n; i++) {
            int a1, a2, a3, a4, a5, a6;
            cin >> a1 >> a2 >> a3 >> a4 >> a5 >> a6;
        }
        cout << 1LL * n * (n - 1) * (n - 2) * (n - 3) / 24 << '\n';
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                for (int k = j + 1; k < n; k++) {
                    for (int c = k + 1; c < n; c++) {
                        cout << i + 1 << " " << j + 1 << " " << k + 1 << " " << c + 1 << '\n';
                    }
                }
            }
        }
    } else if (t == 4 || t == 5) {
        ll n;
        cin >> n;
        vector<prek> a(n);
        for (int i = 0; i < n; i++) {
            for (int k = 0; k < 6; k++) {
                cin >> a[i].x[k];
            }
        }
        vector<T> ans;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                for (int k = j + 1; k < n; k++) {
                    for (int c = k + 1; c < n; c++) {
                        if (get(a[i]) == get(a[j]) && get(a[j]) == get(a[k]) && get(a[k]) == get(a[c]))
                            ans.emplace_back(i + 1, j + 1, k + 1, c + 1);
                    }
                }
            }
        }
        cout << ans.size() << '\n';
        for (auto o : ans) {
            cout << o.a << " " << o.b << " " << o.c << " " << o.d << '\n';
        }
    }
}