#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pii pair<int,int>
#define all(x) x.begin(), x.end()
#define ld long double
#define pld pair<ld,ld>

const int max_n = 2e5 + 2;
const int inf = 1e9 + 7;

struct prek {
    ld x[6];

    prek() {};
};

struct pt {
    double x, y;
    pt(){}
    pt(double x, double y) : x(x), y(y){}
};


double dist(pt pt1, pt pt2) {
    double x = pt1.x - pt2.x;
    double y = pt1.y - pt2.y;
    return sqrt(x * x + y * y);
}

pair<ld,ld> get(prek A){
    pt pt1 = pt(A.x[0], A.x[1]);
    pt pt2 = pt(A.x[2], A.x[3]);
    pt pt3 = pt(A.x[4], A.x[5]);
    ld o1 = dist(pt1, pt2);
    ld o2 = dist(pt2, pt3);
    ld o3 = dist(pt3, pt1);
    ld cnt[3]{o1,o2,o3};
    sort(cnt, cnt + 3);
    return {o1, o2};
}

bool eq(pld o1, pld o2) {
    return (o1.first == o2.first || o1.first == o2.second || o1.second == o2.first || o1.second == o2.second);
}

signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#ifdef EDILYA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;


    struct T {
        int a, b, c, d;
        T(){};
        T(int a, int b, int c, int d) : a(a), b(b), c(c), d(d){}
    };
    if (t == 3) {
        ll n;
        cin >> n;
        for (int i = 0; i < n; i++) {
            int a1, a2, a3, a4, a5, a6;
            cin >> a1 >> a2 >> a3 >> a4 >> a5 >> a6;
        }
        cout << 1LL * n * (n - 1) * (n - 2) * (n - 3) / 24 << '\n';
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                for (int k = j + 1; k < n; k++) {
                    for (int c = k + 1; c < n; c++) {
                        cout << i + 1 << " " << j + 1 << " " << k + 1 << " " << c + 1 << '\n';
                    }
                }
            }
        }
    } else {
        ll n;
        cin >> n;
        vector<prek> a(n);
        for (int i = 0; i < n; i++) {
            for (int k = 0; k < 6; k++) {
                cin >> a[i].x[k];
            }
        }
        vector<T> anss;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (i == j) continue;
                for (int k = 0; k < n; k++){
                    if (i == k || j == k) continue;
                    for (int c = 0; c < n; c++) {
                        if (c == i || c == j || c == k) continue;
                        pld o1 = get(a[i]);
                        pld o2 = get(a[j]);
                        pld o3 = get(a[k]);
                        pld o4 = get(a[c]);
                        bool ans = true;
                        ans &= o1 == o2;
                        ans &= eq(o2, o3);
                        ans &= eq(o3, o4);
                        if (ans)
                            anss.emplace_back(i, j, k, c);
                    }
                }
            }
        }
        set<vector<int>> st;
        vector<T> ans2;
        for (auto o : anss) {
            vector<int> b{o.a, o.b, o.c, o.d};
            sort(all(b));
            if (st.count(b) == 0) {
                st.insert(b);
                ans2.emplace_back(o);
            }
        }
        cout << ans2.size() << '\n';
        for (auto o : ans2) {
            cout << o.a + 1 << " " << o.b + 1 << " " << o.c + 1<< " " << o.d + 1 << '\n';
        }
    }
}