#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pii pair<int,int>
#define all(x) x.begin(),x.end()

int f(int n, int l, int r) {
    return r / n - l / n;
}

const int max_n = 2e5 + 100;
const int inf = 1e9 + 7;

int a[max_n];
int b[max_n];
int n;

pii find(int i, int j) {
    int mn = 0;
    int mx = 0;
    //if ((i + 1) * (j + 1) >= 1e5) return {inf, inf};
    for (int ii = 0; ii < n; ii++) {
        int l = -1;
        int r = n;
        while (l + 1 < r) {
            int mid = (l + r) >> 1;
            int val1 = a[i] * b[mid];
            int val2 = a[ii] * b[j];
            if (val1 <= val2)
                r = mid;
            else l = mid;
        }
        bool c = (l != n - 1 && a[i] * b[l + 1] == a[ii] * b[j]);
        mn += l + 1;
        mx += l + 1 + c;
        //if (mn >= 1e5) return {inf, inf};
    }
    return {mn + 1, mx};
}

signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#ifdef EDILYA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    while (t--) {
        int q;
        cin >> n >> q;
        for (int i = 0; i < n; i++)
            cin >> a[i];
        for (int i = 0; i < n; i++)
            cin >> b[i];
        sort(a, a + n);
        sort(b, b + n, greater<int>());
        if (q > 100) {
            vector<pii > vec;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    //if (n > 500 && (i + 1) * (j + 1) >= (int)1e10) continue;
                    int k1 = a[i];
                    int k2 = b[j];
                    int g = __gcd(k1, k2);
                    k2 /= g;
                    k1 /= g;
                    vec.emplace_back(k1, k2);
                }
            }
            sort(all(vec), [](pii A, pii B) { return A.first * B.second < A.second * B.first; });
            for (int i = 0; i < q; i++) {
                int x;
                cin >> x;
                cout << vec[x - 1].first << " " << vec[x - 1].second << '\n';
            }
        } else {
            while (q--) {
                int x;
                cin >> x;
                pii ans = {0, 0};
                for (int i = 0; i < n; i++) {
                    int l = -1;
                    int r = n;
                    while (l + 1 < r) {
                        int mid = (l + r) >> 1;
                        pii o = find(i, mid);
                        if (o.first <= x)
                            l = mid;
                        else r = mid;
                    }
                    if (l == -1) continue;
                    pii o = find(i, l);
                    if (o.first <= x && x <= o.second) {
                        ans = {i, l};
                        break;
                    }
                }
                int val1 = a[ans.first];
                int val2 = b[ans.second];
                int g = __gcd(val1, val2);
                cout << val1 / g << " " << val2 / g << '\n';
            }
        }
    }
}