#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pii pair<int,int>
#define all(x) x.begin(),x.end()


const int max_n = 2e5 + 100;
const int inf = 1e9 + 7;

int w[max_n];
vector<int> gr[max_n];
int dp[max_n][2]; // dp[i][0] - свободен иначе занят


int solve(vector<pii> a, int k) {
    if (a.empty()) return 0;
    if (k == 0) {
        int sum = 0;
        for (pii c : a)
            sum += c.first;
        return sum;
    }
    k++;
    int n = a.size();
    vector<vector<int>> loc(n, vector<int>(k));
    loc[0][0] = a[0].first;
    loc[0][1] = a[0].second;
    int ans = max(a[0].first, a[0].second);
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < k; j++) {
            loc[i][j] = loc[i - 1][j] + a[i].first;
            if (j > 0)
                loc[i][j] = max(loc[i][j], loc[i - 1][j - 1] + a[i].second);
            ans = max(ans, loc[i][j]);
        }
    }
    return ans;
}

int k;

void dfs(int v, int p) {
    vector<pii> o;
    for (int to : gr[v]) {
        if (to == p) continue;
        dfs(to, v);
        o.emplace_back(dp[to][1], dp[to][0] + 1);
    }
    if (v == 1) {
        int iasda = 0;
    }
    dp[v][0] = solve(o, k - 1);
    dp[v][1] = solve(o, k);
    dp[v][1] = max(dp[v][1], dp[v][0]);
}

signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#ifdef EDILYA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n >> k;
    for (int i = 1; i < n; i++) {
        int p, w_;
        cin >> p >> w_;
        w[i] = w_;
        gr[p - 1].emplace_back(i);
    }
    dfs(0, 0);
    cout << dp[0][1] << " " << '0';
}